/***************************************************************************
 *   Copyright (C) 2007 by ASL-ETH and IIIA-CSIC                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef RANSAC______2345236
#define RANSAC______2345236

#include <vector>
#include <cxcore.h>
#include <cv.h>
#include <highgui.h>
#include "defs.h"
#include "matrice.h"
#include <fstream>
#include <iostream>

void generate3random(int* rand_points,int n_points);
float median(const vector<float>* resid);
Matrice RansacAffine(Match* kp_list,int n_points, vector<int> &inliers, float &error);
void coutmatrix(CvMat* M);
void coutmatrix(CvMat* M, ofstream& pf);
void normalize_pts(Match* kp_list,CvMat **ptso_a,CvMat **ptso_b,CvMat **T1,CvMat **T2);
void normalise2dpts(CvMat *pts, CvMat **newpts, CvMat **T);

#endif
